import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.applet.Applet;
import java.awt.image.*;
import com.sun.image.codec.jpeg.*;

public class pildiredaktor extends Panel implements ActionListener, MouseListener{
  int x=30; //algne joonistuskoht
  int y=50;
  int laius=20;
  int korgus=20;
  int m=100; //max kujundite arv ekraanil, massiivi suurus
  int[] kpx=new int[m]; //massiiv kujundi keskpunkti x-le
  int[] kpy=new int[m]; //massiiv kujundi keskpunkti y-le
  int[] kujund=new int[m]; //massiiv kujundi tbi mramiseks
  int[] varvus=new int[m]; //massiiv kujundi vrvi mramiseks
  int k=0; //kujundiloendur
  int memory; //kujund "mllu"
  int aadress; //kujundi asukoht massiivis

  //nupud ja muu
  BufferedImage pilt=new BufferedImage(400, 300, BufferedImage.TYPE_INT_RGB);
  Graphics2D piltg=pilt.createGraphics();

  String[] varvinimed={"Punane", "Sinine", "Kollane", "Roheline"};
  Color[] varvid={Color.red, Color.blue, Color.yellow, Color.green};
  String[] kujundinimed={"Thi ring", "Tis ring", "Thi ruut", "Tis ruut"};
  
  Button loe=new Button("Loe fail");
  Button salvesta=new Button("Salvesta fail");
  Button joonista=new Button("Joonista kujund");
  TextField tf1=new TextField(20);
  Choice varvivalik=new Choice();
  Choice kujundivalik=new Choice();

  public pildiredaktor(){
    for(int i=0; i<varvinimed.length; i++){ //vrvinimed valikmensse
      varvivalik.addItem(varvinimed[i]);
    }
    for(int i=0; i<kujundinimed.length; i++){
      kujundivalik.addItem(kujundinimed[i]);
    }
    Panel lapaneel=new Panel();
    lapaneel.add(varvivalik);
    lapaneel.add(kujundivalik);
    lapaneel.add(joonista);
    Panel alapaneel=new Panel();
    alapaneel.add(loe);
    alapaneel.add(tf1);
    alapaneel.add(salvesta);
    setLayout(new BorderLayout());
    add(lapaneel, BorderLayout.NORTH);
    add(alapaneel, BorderLayout.SOUTH);
    loe.addActionListener(this);
    salvesta.addActionListener(this);
    joonista.addActionListener(this);
    addMouseListener(this);
  }

  public void paint(Graphics g){
    g.drawImage(pilt, 0, 0, this);
  }
  public void update(Graphics g){ //hoiab vilkumise eemal
    paint(g);
  }

  public void actionPerformed(ActionEvent e){  //nupuvajutused
    try{
      if(e.getSource()==loe){  //faililugemine
        Image failipilt=Toolkit.getDefaultToolkit().getImage(tf1.getText());
        MediaTracker md=new MediaTracker(this);
        md.addImage(failipilt, 0);
        md.waitForAll();
        piltg.drawImage(failipilt, 0, 0, this);
        repaint();
      }
      if(e.getSource()==salvesta){  //failikirjutamine
        FileOutputStream fos=new FileOutputStream(tf1.getText());
        JPEGCodec.createJPEGEncoder(fos).encode(pilt);
        fos.close();
      }
      if(e.getSource()==joonista){  //uue kujundi tekitamine
        joonistakujund();	    //kutsub vlja eraldi funktsiooni
      }
    }catch(Exception ex){ex.printStackTrace();}
  }

  public void joonistakujund(){  //uue kujundi joonistamise funktsioon
    piltg.setColor(varvid[varvivalik.getSelectedIndex()]);
    if(kujundivalik.getSelectedIndex()==0){  //kujund vastavalt valikule
      piltg.drawOval(x, y, laius, korgus);
      kpx[k]=x+laius/2;  //x massiivi
      kpy[k]=y+korgus/2;  //y massiivi
      varvus[k]=varvivalik.getSelectedIndex();  //vrvus massiivi
      kujund[k]=kujundivalik.getSelectedIndex();  //kuju massiivi
      k++;  //suurendan olemasolevate kujundite arvu
    }
    if(kujundivalik.getSelectedIndex()==1){
      piltg.fillOval(x, y, laius, korgus);
      kpx[k]=x+laius/2;
      kpy[k]=y+korgus/2;
      varvus[k]=varvivalik.getSelectedIndex();
      kujund[k]=kujundivalik.getSelectedIndex();
      k++;
    }
    if(kujundivalik.getSelectedIndex()==2){
      piltg.drawRect(x, y, laius, korgus);
      kpx[k]=x+laius/2;
      kpy[k]=y+korgus/2;
      varvus[k]=varvivalik.getSelectedIndex();
      kujund[k]=kujundivalik.getSelectedIndex();
      k++;
    }
    if(kujundivalik.getSelectedIndex()==3){
      piltg.fillRect(x, y, laius, korgus);
      kpx[k]=x+laius/2;
      kpy[k]=y+korgus/2;
      varvus[k]=varvivalik.getSelectedIndex();
      kujund[k]=kujundivalik.getSelectedIndex();
      k++;
    }
    repaint();
  }
  
  public void mousePressed(MouseEvent e){

    if(memory==0){  //kui mlus pole kujundit
      for(int i=0; i<100; i++){  //otsib kas klikkasin kjundil
        if(Math.abs(e.getX()-kpx[i])<laius && Math.abs(e.getY()-kpy[i])<korgus){
          piltg.setColor(Color.black);  //joonistab kujundi le
          piltg.fillRect(kpx[i]-laius/2, kpy[i]-korgus/2, laius+2, korgus+2);
          memory=1;  //paneb kujundi "mllu"
	  aadress=i;  //jtab meelde kujundi asukoha massiivis
        }
      }
      repaint();
      return;  //lheb funktsioonist vlja
    }
    if(memory==1){  //mlus on kujund, mida tahan nihutada
      kpx[aadress]=e.getX();  //kuhu ma tahan nihutada
      kpy[aadress]=e.getY();
      piltg.setColor(varvid[varvus[aadress]]);  //kujundi vrv massiivist

      if(kujund[aadress]==0){  //joonistab kujundi vastavalt kujule
      piltg.drawOval(e.getX()-laius/2, e.getY()-korgus/2, laius, korgus);
      }
      if(kujund[aadress]==1){
      piltg.fillOval(e.getX()-laius/2, e.getY()-korgus/2, laius, korgus);
      }
      if(kujund[aadress]==2){
      piltg.drawRect(e.getX()-laius/2, e.getY()-korgus/2, laius, korgus);
      }
      if(kujund[aadress]==3){
      piltg.fillRect(e.getX()-laius/2, e.getY()-korgus/2, laius, korgus);
      }
      memory=0;  //nullib "mlu"
      repaint();
    }
  }

  public void mouseEntered(MouseEvent e){}
  public void mouseExited(MouseEvent e){}
  public void mouseClicked(MouseEvent e){}
  public void mouseReleased(MouseEvent e){}
    
  public static void main(String[] argumendid){
    Frame f=new Frame();
    f.add(new pildiredaktor());
    f.setSize(400, 300);
    f.setVisible(true);
    f.addWindowListener(new Raamikuular());
  }
}
  class Raamikuular extends WindowAdapter{
     public void windowClosing(WindowEvent e){
           System.out.println(" ");
             System.exit(0);
  }
}