
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;

/**
 * User: Mart Karu
 * Date: 22.04.2003
 * Time: 11:13:25
 */
public class Pildimuutus extends JApplet implements ActionListener
{


    public static final String SYNDMUS_KOPEERI_EKRAAN = "kopeeriekraan";
    public static final String SYNDMUS_MUSTVALGE = "mv";
    public static final String SYNDMUS_SALVESTA = "salvesta";
    public static final String SYNDMUS_LOE = "loe";

    PildiPaneel pildiPaneel = new PildiPaneel();
    JButton bKopeeriEkraan = null;
    JButton bMustValge = null;
    JButton bSalvesta = null;
    JButton bLoe = null;
    JTextArea info = null;

    public Pildimuutus()
    {

        bKopeeriEkraan = new JButton("Kopeeri ekraan!");
        bMustValge = new JButton("Mustvalgeks");
        bSalvesta = new JButton("Salvesta faili");
        bLoe = new JButton("Loe failist");

        bKopeeriEkraan.setActionCommand(Pildimuutus.SYNDMUS_KOPEERI_EKRAAN);
        bMustValge.setActionCommand(Pildimuutus.SYNDMUS_MUSTVALGE);
        bSalvesta.setActionCommand(Pildimuutus.SYNDMUS_SALVESTA);
        bLoe.setActionCommand(Pildimuutus.SYNDMUS_LOE);

        bKopeeriEkraan.addActionListener(this);
        bMustValge.addActionListener(this);
        bSalvesta.addActionListener(this);
        bLoe.addActionListener(this);

        pildiPaneel.setVisible(true);

        JPanel nupuPaneel = new JPanel();
        nupuPaneel.add(bKopeeriEkraan);
        nupuPaneel.add(bMustValge);
        nupuPaneel.add(bSalvesta);
        nupuPaneel.add(bLoe);
        nupuPaneel.setVisible(true);

        info = new JTextArea(10, 100);
        info.setVisible(true);
        JScrollPane scrollPane = new JScrollPane(info);
        JScrollPane pildiScroller = new JScrollPane(pildiPaneel);

        this.getContentPane().setLayout(new BorderLayout());
        this.getContentPane().add(pildiScroller, BorderLayout.CENTER);
        this.getContentPane().add(nupuPaneel, BorderLayout.NORTH);
        this.getContentPane().add(scrollPane, BorderLayout.SOUTH);

    }


    /**
     * Kopeerib ekraani pilt
     * @return kopeeritud ekraan
     */
    private BufferedImage kopeeriEkraaniPilt()
    {

        Robot robot;
        BufferedImage imageReturn = null;

        try
        {
            robot = new Robot();
            imageReturn = robot.createScreenCapture(new Rectangle(0, 0, getWidth(), getHeight()));
        } catch (AWTException e)
        {
            e.printStackTrace();  //To change body of catch statement use Options | File Templates.
        }

        return imageReturn;
    }

    public void actionPerformed(ActionEvent e)
    {

        // kui kopeeriti ekraan
        if (e.getActionCommand().equalsIgnoreCase(Pildimuutus.SYNDMUS_KOPEERI_EKRAAN))
        {
            pildiPaneel.setPilt(kopeeriEkraaniPilt());
            int piksel = pildiPaneel.getYlemineVasakPiksel();
            info.append("Piksel:(" + piksel + ") R:" + Utiil.getR(piksel) + " G:" + Utiil.getG(piksel) + " B:" + Utiil.getB(piksel) + " \n");
        }

        // pilt mustvalgeks!
        if (e.getActionCommand().equalsIgnoreCase(Pildimuutus.SYNDMUS_MUSTVALGE))
        {
            pildiPaneel.teeMustValgeks();
        }

        // salvesta pildi andmed binaarselt faili
        if (e.getActionCommand().equalsIgnoreCase(Pildimuutus.SYNDMUS_SALVESTA))
        {
            File f = new File("c:/test.test");
            pildiPaneel.salvestaFaili(f);
        }

        // loe pilt failist
        if (e.getActionCommand().equalsIgnoreCase(Pildimuutus.SYNDMUS_LOE))
        {
            File f = new File("c:/test.test");
            pildiPaneel.avaFailist(f);
        }

    }

}
