import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.Vector;
import java.io.*;

public class Pildiredaktor extends Applet implements ActionListener, ItemListener, Serializable{

	String kujundiNimed[] = {"Joon", "Ristklik", "Ellips", "Vaba joon"};
	String varviNimed[] = {"Must", "Punane", "Sinine", "Roheline"};
	Color  varvid[] = {Color.black, Color.red, Color.blue, Color.green};
	
	Choice kujundiValik=new Choice();
	Choice varviValik=new Choice();
	
	TextField salvestaTF=new TextField("default.dgt");
	TextField laeTF=new TextField("default.dgt");
	
	Button salvestaB=new Button("Salvesta");
	Button laeB=new Button("Lae");
	
	Panel tooriistaRiba=new Panel();
	
	Joonistusala joonistus=new Joonistusala();
	
	public Pildiredaktor() {
		
		for (int i=0; i<kujundiNimed.length; i++) {
			kujundiValik.addItem(kujundiNimed[i]);	
		}
		for (int i=0; i<varviNimed.length; i++) {
			varviValik.addItem(varviNimed[i]);	
		}
		
		kujundiValik.addItemListener(this);
		varviValik.addItemListener(this);
		
		tooriistaRiba.setLayout(new GridLayout(2,3));
		tooriistaRiba.add(kujundiValik);
		tooriistaRiba.add(salvestaTF);
		tooriistaRiba.add(salvestaB);
		tooriistaRiba.add(varviValik);
		tooriistaRiba.add(laeTF);
		tooriistaRiba.add(laeB);
		
		setLayout(new BorderLayout());
		add(joonistus, BorderLayout.CENTER);
		add(tooriistaRiba, BorderLayout.NORTH);
		
		salvestaB.addActionListener(this);
		laeB.addActionListener(this);
	}
	
	public void actionPerformed(ActionEvent e) {
		
		if(e.getSource()==salvestaB){
			try {
				joonistus.salvesta(salvestaTF.getText().trim());
	
			}catch(Exception viga){}
		}
		if (e.getSource()==laeB){
			try{
				joonistus.lae(laeTF.getText().trim());	
			}catch(Exception viga){}
		}
	}
	
	public void itemStateChanged(ItemEvent i) {
		joonistus.kujundiNr=kujundiValik.getSelectedIndex();
		joonistus.varv=varvid[varviValik.getSelectedIndex()];
	}

	public static void main(String argumendid[]){
		Frame aken=new Frame("Pildiredaktor");
		aken.setLocation(10, 40);
		aken.setSize(800, 600);
		aken.setBackground(Color.white);
		aken.add(new Pildiredaktor());
		aken.setVisible(true);
		aken.addWindowListener(new Raamikuular());
	}
}

class Raamikuular extends WindowAdapter{
	public void windowClosing(WindowEvent e) {
		System.out.println("X-st kinni");
		System.exit(0);
	}
}

class Joonistusala extends Canvas implements MouseListener, MouseMotionListener{

	Point2D.Float algusPunkt;
	Point2D.Float loppPunkt;

    	int kujundiNr=0;

    	Kujund valmisKujund;
    	Kujund uusKujund;
    	KujundiAndmed kAndmed;
    	GeneralPath vabaJoon;
    	
    	Vector kujundidAndmetega=new Vector();
    	Vector kujundid=new Vector();
    	Color varv;
		
	public Joonistusala(){
		
		addMouseListener(this);
		addMouseMotionListener(this);				

	}

	public void salvesta(String failiNimi){
		if (failiNimi.length()!=0){
			System.out.println(kujundidAndmetega.size());
			try{
				FileOutputStream failiVoog=new FileOutputStream(failiNimi);
				ObjectOutputStream objektiVoog=new ObjectOutputStream(failiVoog);
				for (int a=0;a<kujundidAndmetega.size();a++){
					objektiVoog.writeObject(kujundidAndmetega.elementAt(a));
				}
				objektiVoog.flush();
				failiVoog.close();
				
			}catch(Exception viga){
				System.out.println("Viga salvestamisel: "+viga.getMessage());	
			}
			System.out.println("Vajutati 'salvesta' nuppu");
			System.out.println(kujundidAndmetega.size());
		}else {
			System.out.println("Failinimi on puudu");	
		}
	}
	
	public void lae(String failiNimi){
		if (failiNimi.length()!=0){
			try{
				FileInputStream failiVoog=new FileInputStream(failiNimi);
				ObjectInputStream objektiVoog=new ObjectInputStream(failiVoog);
				kujundidAndmetega=new Vector();
				
				try{
					while(true){
						kujundidAndmetega.add((KujundiAndmed)objektiVoog.readObject());
					}
				}catch(EOFException viga){}
				
				failiVoog.close();
				System.out.println("Vajutati 'lae' nuppu");
				
				
				
			}catch(Exception viga){
					System.out.println("Viga faili lugemisel: "+viga);	
			}
			System.out.println("kujundidAndmetega: "+kujundidAndmetega.size());
			konverdiAndmedKujunditeks(kujundidAndmetega);			
			repaint();
		}else {
			System.out.println("Failinimi on puudu");	
		}
		
	}
	
	public void konverdiAndmedKujunditeks(Vector kujundidAndmetega){
		kujundid=new Vector();
		for (int a=0;a<=kujundidAndmetega.size();a++){
			kAndmed=(KujundiAndmed)kujundidAndmetega.elementAt(a);
			
			algusPunkt=new Point2D.Float(Float.parseFloat((String)kAndmed.koordinaadid.elementAt(0)), Float.parseFloat((String)kAndmed.koordinaadid.elementAt(1)));
			loppPunkt=new Point2D.Float(Float.parseFloat((String)kAndmed.koordinaadid.elementAt(2)), Float.parseFloat((String)kAndmed.koordinaadid.elementAt(3)));
			float x=Math.min(algusPunkt.x, loppPunkt.x);
			float y=Math.min(algusPunkt.y, loppPunkt.y);
			float laius=Math.abs(loppPunkt.x-algusPunkt.x);
			float korgus=Math.abs(loppPunkt.y-algusPunkt.y);
			
			Kujund k=new Kujund();
			switch(kAndmed.tyyp){
				case 0: k.kuju=new Line2D.Float(algusPunkt, loppPunkt);
					k.varv=kAndmed.varv;
					break;	
				case 1: k.kuju=new Rectangle2D.Float(x, y, laius, korgus);
					k.varv=kAndmed.varv;
					break;
				case 2: k.kuju=new Ellipse2D.Float(x, y, laius, korgus);
					k.varv=kAndmed.varv;
					break;
			}
			kujundid.add(k);
			repaint();
			
		}
		System.out.println("konverdiAndmedKujunditeks-kujundid: "+kujundid.size());
			
	}	
	
	public Kujund joonistaKujund(Kujund k){
		
		float x=Math.min(algusPunkt.x, loppPunkt.x);
		float y=Math.min(algusPunkt.y, loppPunkt.y);
		float laius=Math.abs(loppPunkt.x-algusPunkt.x);
		float korgus=Math.abs(loppPunkt.y-algusPunkt.y);
		
		switch(kujundiNr){
			case 0: k.kuju=new Line2D.Float(algusPunkt, loppPunkt);
				break;
			case 1: k.kuju=new Rectangle2D.Float(x, y, laius, korgus);
				break;
			case 2: k.kuju=new Ellipse2D.Float(x, y, laius, korgus);
				break;
		}
		
		return k;
	
	}
	
	
	
	public void paint(Graphics algg) {
		Graphics2D g=(Graphics2D)algg;
		
		for (int a=0; a<kujundid.size(); a++){
			valmisKujund=(Kujund)kujundid.elementAt(a);
			g.setColor(valmisKujund.varv);
			g.draw(valmisKujund.kuju);
		}

		if (uusKujund!=null) {
			if(uusKujund.varv!=null){
				g.setColor(uusKujund.varv);
			} else {
				g.setColor(Color.gray);
			}
			g.draw(uusKujund.kuju);
		}
	}
	
	public void update(Graphics g){
		paint(g);	
	}
	
	public void mousePressed(MouseEvent e){
		if(kujundiNr!=3){
			algusPunkt=new Point2D.Float(e.getX(), e.getY());
			loppPunkt=new Point2D.Float(e.getX(), e.getY());
			uusKujund=joonistaKujund(new Kujund());
		} else {
			vabaJoon=new GeneralPath();
			uusKujund=new Kujund();
			uusKujund.varv=varv;
		}
	}
	
	public void mouseReleased(MouseEvent e){
		if(kujundiNr!=3){
			loppPunkt=new Point2D.Float(e.getX(), e.getY());
			valmisKujund=joonistaKujund(new Kujund());
			valmisKujund.varv=varv;
			kujundid.add(valmisKujund);
			uusKujund=null;
			
			kAndmed=new KujundiAndmed();
			kAndmed.tyyp=kujundiNr;
			kAndmed.varv=varv;
			kAndmed.koordinaadid.add(""+algusPunkt.x);
			kAndmed.koordinaadid.add(""+algusPunkt.y);
			kAndmed.koordinaadid.add(""+loppPunkt.x);
			kAndmed.koordinaadid.add(""+loppPunkt.y);
			kujundidAndmetega.add(kAndmed);
			
		} else {
			valmisKujund=new Kujund();
			valmisKujund.kuju=vabaJoon;
			valmisKujund.varv=varv;
			kujundid.add(valmisKujund);
			vabaJoon=null;
			uusKujund=null;
		}
		repaint();
	}
	public void mouseClicked(MouseEvent e){}
	public void mouseEntered(MouseEvent e){}
	public void mouseExited(MouseEvent e){}
	
	public void mouseDragged(MouseEvent e){
		if(kujundiNr!=3){
			loppPunkt=new Point2D.Float(e.getX(), e.getY());
			uusKujund=joonistaKujund(uusKujund);
			uusKujund.varv=null;
		} else {
			vabaJoon.append((Shape)(new Line2D.Float(e.getX(), e.getY(), e.getX(), e.getY())), true);
			uusKujund.kuju=vabaJoon;
		}
		repaint();
	}
	public void mouseMoved(MouseEvent e){}		
}

class Kujund{
	Shape kuju;
	Color varv;
}

class KujundiAndmed implements Serializable{

	int tyyp;
	Vector koordinaadid=new Vector();
	Color varv;
	
}
























/*
class Joonistusala extends Canvas implements MouseListener, MouseMotionListener{
	
	Point2D.Float algusPunkt;
	Point2D.Float loppPunkt;
	
	int kujundiNr;
	Color varv;

	KujundiAndmed kAndmed;
	Shape kujund;
	
	public Joonistusala(){
		addMouseListener(this);	
		addMouseMotionListener(this);
	}
	
	public Shape joonistaKujund(KujundiAndmed ka){
		
		float x=Math.min(algusPunkt.x, loppPunkt.x);
		float y=Math.min(algusPunkt.y, loppPunkt.y);
		float laius=Math.abs(loppPunkt.x-algusPunkt.x);
		float korgus=Math.abs(loppPunkt.y-algusPunkt.y);
		
		switch(kujundiNr){
			case 0: kujund=new Line2D.Float(algusPunkt, loppPunkt);
				break;
			case 1: kujund=new Rectangle2D.Float(x, y, laius, korgus);
				break;
			case 2: kujund=new Ellipse2D.Float(x, y, laius, korgus);
				break;
		}
		return kujund;
		
	}
	
	public void paint(Graphics algg){
		Graphics2D g=(Graphics2D)algg;
		
		if (kujund!=null){
			
			g.draw(kujund);
		}
		
	}
	
	public void mousePressed(MouseEvent e){
		kAndmed=new KujundiAndmed();
		algusPunkt=new Point2D.Float(e.getX(), e.getY());
		loppPunkt=new Point2D.Float(e.getX(), e.getY());

		kAndmed.tyyp=kujundiNr;
		kAndmed.koordinaadid.add(""+e.getX());
		kAndmed.koordinaadid.add(""+e.getY());
		kAndmed.koordinaadid.add(""+e.getX());
		kAndmed.koordinaadid.add(""+e.getY());

		kujund=joonistaKujund(kAndmed);	
	}
	public void mouseReleased(MouseEvent e){
		loppPunkt=new Point2D.Float(e.getX(), e.getY());
		joonistaKujund(kAndmed);	
		repaint();
	}
	public void mouseClicked(MouseEvent e){}
	public void mouseEntered(MouseEvent e){}
	public void mouseExited(MouseEvent e){}
	
	public void mouseDragged(MouseEvent e){
		loppPunkt=new Point2D.Float(e.getX(), e.getY());
		kujund=joonistaKujund(kAndmed);
		repaint();
	}
	public void mouseMoved(MouseEvent e){}	
}

class KujundiAndmed implements Serializable{
	int tyyp;
	Vector koordinaadid;
	Color varv;
}


*/