import com.sun.image.codec.jpeg.*;  
import java.lang.String.*;
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;

public class Redaktor extends Applet implements MouseListener, ActionListener {
  int allaX, allaY;
  int suurendus=2;
  int pildilaius=1024, pildikorgus=768;
  BufferedImage pilt=new BufferedImage(pildilaius, pildikorgus, BufferedImage.TYPE_INT_RGB);
  Graphics2D piltg=pilt.createGraphics();
  String varvinimed[]={"kollane","punane","sinine", "must", "roheline"};
  Color varvid[]={Color.yellow, Color.red, Color.blue, Color.black, Color.green};
  Choice valik=new Choice();
  TextField avanimi=new TextField(10);
  TextField salvnimi=new TextField(10);
  String kujunimed[]={"ruut", "t?idetud ruut", "ring", "t?idetud ring", "joon", "kopi", "kleebi"};
  Choice valik2=new Choice();
  Button salvesta=new Button("salvesta fail");
  Button ava=new Button("ava fail");
  BufferedImage puhver;

  public Redaktor(){
	addMouseListener(this);
	for(int i=0; i<varvinimed.length; i++){
	  valik.addItem(varvinimed[i]);	
	}
	for(int i=0; i<kujunimed.length; i++){
	  valik2.addItem(kujunimed[i]);	
	}
	add(valik);
	add(valik2);
	add(salvesta);
	add(salvnimi);
	add(ava);	
	add(avanimi);
	ava.addActionListener(this);
	salvesta.addActionListener(this);
	piltg.setColor(Color.white);
	piltg.fillRect(0,0,pildilaius, pildikorgus);
  }

  public void update(Graphics g){
  	paint(g);
  }
  
  int ex(int px){
    return px*suurendus;
  }
  
  int ey(int py){
    return py*suurendus;
  }
  
  int px(int ex){
    return ex/suurendus;
  }
  
  int py(int ey){
    return ey/suurendus;
  }
  public void paint(Graphics g){
        g.drawImage(pilt, 0, 0, pildilaius, pildikorgus, this);
  }  
  public void mousePressed(MouseEvent e){
    allaX=e.getX();
    allaY=e.getY();
    if(valik2.getSelectedIndex()==6){
      piltg.drawImage(puhver, allaX, allaY, this);
      repaint();
  }
  }
  public void mouseReleased(MouseEvent e){
  piltg.setColor(varvid[valik.getSelectedIndex()]);
  int vx=Math.min(allaX, px(e.getX()));
  int vy=Math.min(allaY, py(e.getY()));
  int laius=Math.abs(allaX-px(e.getX()));
  int korgus=Math.abs(allaY-py(e.getY()));
   
  if(valik2.getSelectedIndex()==0){
     piltg.drawRect(vx, vy, laius, korgus);
   }
  if(valik2.getSelectedIndex()==1){
     piltg.fillRect(vx, vy, laius, korgus);
  }       
  if(valik2.getSelectedIndex()==2){
     piltg.drawOval(vx, vy, laius, korgus);
  }     
  if(valik2.getSelectedIndex()==3){
   piltg.fillOval(vx, vy, laius, korgus); 
  }
  if(valik2.getSelectedIndex()==4){
   piltg.drawLine(allaX, allaY, e.getX(), e.getY()); 
  }  
  if(valik2.getSelectedIndex()==5){
   puhver=new BufferedImage(laius, korgus, BufferedImage.TYPE_INT_RGB);
   Graphics2D puhverg=puhver.createGraphics();
   puhverg.drawImage(pilt, -vx, -vy, this);
   System.out.println(vx + vy);
  }
   repaint();
  }
  

  public void mouseClicked(MouseEvent e){}
  public void mouseEntered(MouseEvent e){}
  public void mouseExited(MouseEvent e){}
  
  public void actionPerformed(ActionEvent e){
try{
  if(e.getSource() == salvesta){

    FileOutputStream fos=new FileOutputStream(salvnimi.getText());
    JPEGCodec.createJPEGEncoder(fos).encode(pilt);
    fos.close();
  }else{
    byte[] sisu=new byte[(int)new File(avanimi.getText()).length()];
    FileInputStream sisse=new FileInputStream(avanimi.getText());
    sisse.read(sisu);
    sisse.close();
    Image pildike=Toolkit.getDefaultToolkit().createImage(sisu);;
	   MediaTracker md=new MediaTracker(this);
   	md.addImage(pildike, 0);
   	md.waitForAll();
		piltg.drawImage(pildike, 0, 0, this);
   	repaint();
	  }  

  }catch(Exception ex){
   	ex.printStackTrace();
   }
}

  public static void main(String argumendid[]){
    Frame f=new Frame("Redaktor");
    f.add(new Redaktor());
    f.setSize(600, 600);
    f.setVisible(true);
    f.addWindowListener(new Raami2kuular());

  }
}
class Raami2kuular extends WindowAdapter{
  public void windowClosing(WindowEvent e){
    System.exit(0);
  }
}
