import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import com.sun.image.codec.jpeg.*;
import java.io.*;


public class Pildiredaktor7 extends Applet 
   implements MouseListener, ActionListener{
  int pildilaius=300, pildikorgus=300;
  int suurendus=2;
  BufferedImage pilt=new BufferedImage(pildilaius, pildikorgus, BufferedImage.TYPE_INT_RGB);
  Graphics2D piltg=pilt.createGraphics();
  String[] varvinimed={"Punane", "Sinine", "Kollane"};
  Color[] varvid={Color.red, Color.blue, Color.yellow};
  String[] kujundinimed={"Thi ovaal", "Tis ovaal", 
                   "Thi ristklik", "Tis ristklik", "Joon", "Kopeeri", "Kleebi"};
  int allaX, allaY;
  Choice varvivalik=new Choice();
  Choice kujundivalik=new Choice();
  Button salvestusnupp=new Button("Salvesta");
  Button lugemisnupp=new Button("Loe");
  BufferedImage puhver;
  

  public Pildiredaktor7(){
    addMouseListener(this);
    for(int i=0; i<varvinimed.length; i++){
      varvivalik.addItem(varvinimed[i]);
    }
    for(int i=0; i<kujundinimed.length; i++){
      kujundivalik.addItem(kujundinimed[i]);
    }
    add(varvivalik);
    add(kujundivalik);
    add(salvestusnupp);
    salvestusnupp.addActionListener(this);
    add(lugemisnupp);
    lugemisnupp.addActionListener(this);
  }
  int ex(int px){
    return px*suurendus;
  }
  int ey(int py){
    return py*suurendus;
  }
  int px(int ex){
    return ex/suurendus;
  }
  int py(int ey){
    return ey/suurendus;
  }
  
  public void paint(Graphics g){   
      g.drawImage(pilt, 0, 0, pildilaius*suurendus, pildikorgus*suurendus, this);
  }
  public void update(Graphics g){paint(g);} //hoiab vilkumise eemal

  public void mousePressed(MouseEvent e){
    allaX=px(e.getX());
    allaY=py(e.getY());
    if(kujundivalik.getSelectedIndex()==6){ //kleebi
      if(puhver!=null){
        piltg.drawImage(puhver, allaX, allaY, this);
        repaint();
      }
    }
  }
  public void mouseReleased(MouseEvent e){
    piltg.setColor(varvid[varvivalik.getSelectedIndex()]);
    int vyx=Math.min(allaX, px(e.getX()));
    int vyy=Math.min(allaY, py(e.getY()));
    int laius=Math.abs(allaX-px(e.getX()));
    int korgus=Math.abs(allaY-py(e.getY()));
    if(kujundivalik.getSelectedIndex()==0){
      piltg.drawOval(vyx, vyy, laius, korgus);
    }
    if(kujundivalik.getSelectedIndex()==1){
      piltg.fillOval(vyx, vyy, laius, korgus);
    }
    if(kujundivalik.getSelectedIndex()==2){
      piltg.drawRect(vyx, vyy, laius, korgus);
    }
    if(kujundivalik.getSelectedIndex()==3){
      piltg.fillRect(vyx, vyy, laius, korgus);
    }
    if(kujundivalik.getSelectedIndex()==4){
      piltg.drawLine(allaX, allaY, px(e.getX()), px(e.getY()));
    }
    if(kujundivalik.getSelectedIndex()==5){  //kopeeri
       puhver=new BufferedImage(laius, korgus, BufferedImage.TYPE_INT_RGB);
       Graphics2D puhverg=puhver.createGraphics();
       puhverg.drawImage(pilt, -vyx, -vyy, this);
    }

    repaint();
  }
  public void mouseClicked(MouseEvent e){}
  public void mouseEntered(MouseEvent e){}
  public void mouseExited(MouseEvent e){}
  
  public void actionPerformed(ActionEvent e){
    try{
     if(e.getSource()==lugemisnupp){
       Image failipilt=Toolkit.getDefaultToolkit().getImage("pilt1.jpg");
       MediaTracker md=new MediaTracker(this);
       md.addImage(failipilt, 0);
       md.waitForAll();
       piltg.drawImage(failipilt, 0, 0, this);
       repaint();
     }
     if(e.getSource()==salvestusnupp){
      FileOutputStream fos=new FileOutputStream("pilt1.jpg");
      JPEGCodec.createJPEGEncoder(fos).encode(pilt);
      fos.close();
     }
     
    }catch(Exception ex){
      ex.printStackTrace();
    }
  }

  public static void main(String[] arg){
    Frame f=new Frame();
    f.add(new Pildiredaktor7());
    f.setSize(400, 400);
    f.setVisible(true);
  }
}