/*
 * (C)(P)2003 Mart Karu, TPU, <karu@metal.ee>
 *
 * User: karu
 * Date: Apr 22, 2003
 * Time: 12:29:29 AM
 */

import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.util.*;

public class EditorRaam extends JPanel
{
	public static final String SYNDMUS_MANGI = "mngi";
	public static final String SYNDMUS_STOP = "stop";

	private final int rajaKorgus = 30;
	private final ArrayList heliJupid = new ArrayList();
	private int mangijaPositsioon = 0;
	private int maxPikkus = 0;
	private float skaleerimisFaktor = 1;
	private MasterPlayerThread player = null;

	public EditorRaam()
	{
		setLayout( null );
		init();
	}


	private void init()
	{
		heliJupid.add( new HeliJupp( new File( new File( "" ).getAbsolutePath() + "/husdaralo.wav" ) ) );
		heliJupid.add( new HeliJupp( new File( new File( "" ).getAbsolutePath() + "/kerekgyarto.wav" ) ) );
		heliJupid.add( new HeliJupp( new File( new File( "" ).getAbsolutePath() + "/kutban.wav" ) ) );
		heliJupid.add( new HeliJupp( new File( new File( "" ).getAbsolutePath() + "/nepdal.wav" ) ) );

		ehitaJupid();
	}

	private void ehitaJupid()
	{
		// leiame max pikkuse:
		for ( int i = 0; i < heliJupid.size(); i++ )
		{
			HeliJupp jupp = ( HeliJupp ) heliJupid.get( i );
			maxPikkus = Math.max( maxPikkus, jupp.getHeliPikkus() );
			this.add( jupp );
			jupp.setLocation( 0, i * rajaKorgus + 1 );
			jupp.setVisible( true );
		}

	}

	private void joonistaJupid()
	{
		this.skaleerimisFaktor = Float.parseFloat( getWidth() + "" ) / Float.parseFloat( maxPikkus + "" );
		for ( int i = 0; i < heliJupid.size(); i++ )
		{
			HeliJupp jupp = ( HeliJupp ) heliJupid.get( i );
			jupp.setSize( ( int ) ( jupp.getHeliPikkus() * skaleerimisFaktor ), rajaKorgus - 2 );
		}
	}


	public void paint( Graphics g )
	{
		super.paint( g );
		joonistaRajad( g );
		joonistaJupid();
		g.drawLine( ( mangijaPositsioon ), 0, ( mangijaPositsioon ), getHeight() );
	}

	private void joonistaRajad( Graphics g )
	{
		g.setColor( Color.BLACK );
		for ( int i = 0; i < heliJupid.size(); i++ )
			g.drawLine( 0, ( i + 1 ) * rajaKorgus, getWidth(), ( i + 1 ) * rajaKorgus );
		g.setColor( Color.red );
	}

	public void mangi()
	{
		if ( player != null ) return;
		player = new MasterPlayerThread( this );
		player.start();

	}

	public void seiska()
	{
		mangijaPositsioon = 0;
		if ( player != null )
			player.seisata();
		player = null;
	}

	public void setMangijaPositsioon( int mangijaPositsioon )
	{
		this.mangijaPositsioon = mangijaPositsioon;
		repaint();
	}

	public ArrayList getHeliJupid()
	{
		return heliJupid;
	}

	public int getMaxPikkus()
	{
		return maxPikkus;
	}

}
